Panda3D

Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
SliderTable Class Reference

Stores the total set of VertexSliders that the vertices in a particular GeomVertexData object might depend on. More...

`#include "sliderTable.h"`

Inheritance diagram for SliderTable:

## Public Member Functions
| SliderTable (const SliderTable &copy)
size_t | add_slider (const VertexSlider *slider, const SparseArray &rows)
| Adds a new slider to the table, and returns the index number of the new slider. More...
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
const SparseArray & | find_sliders (const InternalName *name) const
| Returns a list of slider indices that represent the list of sliders with the indicated name, or an empty SparseArray if no slider in the table has that name. More...
virtual TypeHandle | force_init_type ()
UpdateSeq | get_modified (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_sliders () const
const VertexSlider * | get_slider (size_t n) const
const SparseArray & | get_slider_rows (size_t n) const
| Returns the set of rows (vertices) governed by the nth slider in the table. More...
virtual TypeHandle | get_type () const
bool | has_slider (const InternalName *name) const
| Returns true if the table has at least one slider by the indicated name, false otherwise. More...
bool | is_empty () const
| Returns true if the table has no sliders, false if it has at least one. More...
bool | is_registered () const
| Returns true if this table has been registered. More...
void | operator= (const SliderTable &copy)
void | remove_slider (size_t n)
| Removes the nth slider. More...
void | set_slider (size_t n, const VertexSlider *slider)
| Replaces the nth slider. More...
void | set_slider_rows (size_t n, const SparseArray &rows)
| Replaces the rows affected by the nth slider. More...
void | write (std::ostream &out) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static | CPT (SliderTable) register_table(const SliderTable *table)
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type SliderTable. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_modified
| Returns a sequence number that's guaranteed to change at least when any VertexSliders in the table change. More...
| get_num_sliders
| Returns the number of sliders in the table. More...
| get_slider
| Returns the nth slider in the table. More...
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Friends
class | VertexSlider

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Stores the total set of VertexSliders that the vertices in a particular GeomVertexData object might depend on.

This is similar to a TransformTable, but it stores VertexSliders instead of VertexTransforms, and it stores them by name instead of by index number. Also, it is only used when animating vertices on the CPU, since GPU's don't support morphs at this point in time.

Definition at line 37 of file sliderTable.h.

## Member Function Documentation

## ◆ add_slider()

size_t SliderTable::add_slider | ( | const VertexSlider * | slider,
|  | const SparseArray & | rows
| ) |  |

Adds a new slider to the table, and returns the index number of the new slider.

Only valid for unregistered tables.

Definition at line 108 of file sliderTable.cxx.

## ◆ complete_pointers()

int SliderTable::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager
| ) |  |
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 197 of file sliderTable.cxx.

## ◆ find_sliders()

const SparseArray & SliderTable::find_sliders | ( | const InternalName * | name | ) | const
| inline

Returns a list of slider indices that represent the list of sliders with the indicated name, or an empty SparseArray if no slider in the table has that name.

Definition at line 80 of file sliderTable.I.

## ◆ get_slider_rows()

const SparseArray & SliderTable::get_slider_rows | ( | size_t | n | ) | const
| inline

Returns the set of rows (vertices) governed by the nth slider in the table.

Definition at line 69 of file sliderTable.I.

## ◆ has_slider()

bool SliderTable::has_slider | ( | const InternalName * | name | ) | const
| inline

Returns true if the table has at least one slider by the indicated name, false otherwise.

Definition at line 94 of file sliderTable.I.

## ◆ is_empty()

bool SliderTable::is_empty | ( |  | ) | const
| inline

Returns true if the table has no sliders, false if it has at least one.

Definition at line 102 of file sliderTable.I.

## ◆ is_registered()

bool SliderTable::is_registered | ( |  | ) | const
| inline

Returns true if this table has been registered.

Once it has been registered, the set of sliders in a SliderTable may not be further modified; but it must be registered before it can be assigned to a Geom.

Definition at line 19 of file sliderTable.I.

## ◆ register_with_read_factory()

void SliderTable::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type SliderTable.

Definition at line 169 of file sliderTable.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ remove_slider()

void SliderTable::remove_slider | ( | size_t | n | ) |

Removes the nth slider.

Only valid for unregistered tables.

Definition at line 95 of file sliderTable.cxx.

## ◆ set_slider()

void SliderTable::set_slider | ( | size_t | n,
|  | const VertexSlider * | slider
| ) |  |

Replaces the nth slider.

Only valid for unregistered tables.

Definition at line 65 of file sliderTable.cxx.

## ◆ set_slider_rows()

void SliderTable::set_slider_rows | ( | size_t | n,
|  | const SparseArray & | rows
| ) |  |

Replaces the rows affected by the nth slider.

Only valid for unregistered tables.

Definition at line 82 of file sliderTable.cxx.

## ◆ write_datagram()

void SliderTable::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  |
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 178 of file sliderTable.cxx.

References Datagram::add_uint16(), BamWriter::write_cdata(), TypedWritable::write_datagram(), and BamWriter::write_pointer().

## Member Data Documentation

## ◆ get_modified

UpdateSeq SliderTable::get_modified
| inline

Returns a sequence number that's guaranteed to change at least when any VertexSliders in the table change.

(However, this is only true for a registered table. An unregistered table may or may not reflect an update here when a VertexSlider changes.)

Definition at line 56 of file sliderTable.h.

## ◆ get_num_sliders

size_t SliderTable::get_num_sliders
| inline

Returns the number of sliders in the table.

Definition at line 49 of file sliderTable.h.

## ◆ get_slider

const VertexSlider * SliderTable::get_slider
| inline

Returns the nth slider in the table.

Definition at line 49 of file sliderTable.h.

The documentation for this class was generated from the following files:

- panda/src/gobj/sliderTable.h
- panda/src/gobj/sliderTable.cxx
- panda/src/gobj/sliderTable.I